<?php

    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;
    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;

	require_once("lib/fconnect.php");
	$db = DBConnect::getInstance();

    require_once("lib/frole.php");
    $role = new Role();
	$role->isPageEnable($user->uuid);

	require_once("lib/fhighcharts.php");
	$chatrs = new HighCharts();

	function debug($data){
		if(is_string($data)){
			echo '<p>'.$data.'</p>';
		}else{
			echo '<pre>'.var_dump($data).'</pre>';
		}
	}

	function actualDate(){
		$day 	= (int)date("d");
		$month 	= (int)date("m");
		$year 	= (int)date("Y");
		if($day<=26){
			$month--;
			if($month==0){
				$year--;
				$month = 12;
			}
		}
		return '26.'.$month.'.'.$year;
	}

	function divide_on_the_rates($chislo, $rates, $round = 5){
	//	if(round($chislo/$rates,$round)<0)debug('divide_on_the_rates '.round($chislo/$rates,$round));

		return round($chislo/$rates,$round);
	}

	function actuation($array,$value){
		arsort($array);
		$max = reset($array);
		if($max == 0) return 0;
		$percent = ($max)/100;
		return ($value)/$percent;
	}

# LETS BEGIN!
$i = 0;
$arr=array();
$out['head'] = '';
$out['body'] = '';
$params = $db->colModel->findOne( array('name'=>'chair'));
if (!isset($_GET['chairtype'])) $_GET['chairtype'] = '';
switch($_GET['chairtype']){
	case 'E':
		$what = array('type'=>'chair','chairtype'=>'E');
		$plotcolor = '#699954';
		$heading = 'Рейтинг кафедр естественнонаучного профиля';
	break;
	case 'G':
		$what = array('type'=>'chair','chairtype'=>'G');
		$plotcolor = '#A75C69';
		$heading = 'Рейтинг кафедр гуманитарного профиля';
	break;
	case 'T':
		$what = array('type'=>'chair','chairtype'=>'T');
		$plotcolor = '#B29162';
		$heading = 'Рейтинг кафедр творческого профиля';
	break;
	case 'P':
		$what = array('type'=>'chair','chairtype'=>'P');
		$plotcolor = '#90708C';
		$heading = 'Рейтинг кафедр педагогического профиля';
	break;
	default:
		$what = array('type'=>'chair');
		$plotcolor = '#435C73';
		$heading = 'Рейтинг кафедр университета';
}

$faculties = $db->colDocs->find(array('type'=>'faculty'));
$faculties_menu = '
<div class="form-group">
<form method="post" class="form-inline" action="rating.php">
<select class="form-control" name="faculty">';
foreach($faculties as $faculty){
	$faculties_menu .= '
	<option value="'.$faculty['uuid'].'">'.$faculty['title_ru'].'</option>';
	if(isset($_POST['faculty']) && $_POST['faculty']==$faculty['uuid']) {$what = array('type' => 'chair', 'parent' => $_POST['faculty']);
	$fchairs = $db->colDocs->find($what);
		foreach($fchairs as $fchair){
			$flist[$fchair['title_ru']] = true;
		}
	}
}
		$what = array('type'=>'chair');

$faculties_menu .='
</select>
<input class="btn btn-default" type="submit" value="Смотреть!">
</form>
</div>';
$chairs = $db->colDocs->find($what);
foreach($chairs as $chair){
	//var_dump($chair);
	if(!isset($chair['chairtype'])){
	$chair['chairtype'] = 'P';
	var_dump('Не указан профиль - '.$chair['title_ru']);
	}
	$chairtypes[$chair['title_ru']] = $chair['chairtype'];
}
$chairsCounter =  $db->colDocs->count($what);
$now = actualDate();
$itemlist = '
<table>';
foreach($params['items'] as $item){
	if(isset($item['pdf']) && $item['pdf']){

		# вес показателей
		if(isset($item['pdf']) && $item['pdf']){
			if(isset($item['weight']) && $item['weight']>0){
				$weightlist[$item['index_code_ru']]['weight'] = $item['weight'];
				switch($item['type']){
				case 'section':
					$weightlist[$item['index_code_ru']]['type']='section';
				break;
				case 'subsection':
					$weightlist[$item['index_code_ru']]['type']='subsection';
				break;
				default:
					$weightlist[$item['index_code_ru']]['type']='item';
				}
			}else{
				$weightlist[$item['index_code_ru']]['weight'] = 0;
			//	$out['body'] .= '<p style="color:red;">У показателя с индексом ' . $item['index_code_ru'] . ' проблема "с весом"!!!</p>';
			}
		}
		# вес показателей

		$j = 0;
		if(isset($item['type'])){
			if($item['type'] == 'section'){
				//лишнее
				$itemtitles[$item['index_code_ru']] = $item['label_ru'];
				//$out['body'] .= '<div><h3 style="text-align:center;margin-top:45px;" id="' . $item['name'] . '">Раздел '.++$i.': <b>'.$item['label_ru'].'</b></h3></div>';
			}elseif($item['type'] == 'subsection'){
				//лишнее
				$itemtitles[$item['index_code_ru']] = $item['label_ru'];
				//$subtext = $item['label_ru'];
			}else{
				//$title = addcslashes($item['index_code_ru'].' '.$subtext.' '.$item['label_ru'], "'");
				//$title = addcslashes($title, '"');
				if($item['accumulative']){
					foreach($chairs as $chair){
						if(isset($chair[$item['name']])){
							$values[$chair['title_ru']] = $chair[$item['name']];
							if(!isset($chair['rates'])){
								$chair['rates']=1;
								var_dump('Не указаны ставки - '.$chair['title_ru']);
								} //плохо
							$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
							//if($values[$chair['title_ru']]<0)$values[$chair['title_ru']] = -$values[$chair['title_ru']];
						}
					}
				}else{
					foreach($chairs as $chair){
						$counter = 0;
						if(isset($chair[$item['name']])){
							$values[$chair['title_ru']] = $chair[$item['name']];
							if(isset($chair['versions'])){
								foreach($chair['versions'] as $version){
									$counter++;
									// if($counter < 10) continue;

									if(isset($version['content']) && isset($version['content'][$item['name']])){
										$values[$chair['title_ru']] += $version['content'][$item['name']];
									}
								}
							}
							if(!isset($chair['rates'])){
								$chair['rates']=1;
								var_dump('Не указаны ставки - '.$chair['title_ru']);
								} //плохо
						$values[$chair['title_ru']] = divide_on_the_rates($values[$chair['title_ru']],$chair['rates']);
						}else{
							$values[$chair['title_ru']] = 0;
						}
					}
				}
				arsort($values);

			//	debug($item['index_code_ru']. ', вес: ' .$weightlist[$item['index_code_ru']]['weight']);
			//	debug('Кафедра русского языка: '.$values['Кафедра русского языка']);
			//	debug('Кафедра начального естественно-математического образования: '.$values['Кафедра начального естественно-математического образования']);
			//	debug('Кафедра управления образованием и кадрового менеджмента: '.$values['Кафедра управления образованием и кадрового менеджмента']);
				foreach($values as $key=>$value){
					if($value<0){
						$values[$key]=0;

					//	$out['body'] .= '<p style="color:red;"> Проблема с подразделением: "'.$key.'", показатель: "'.$item['index_code_ru'].'" = '.$value.' <b>в расчетах будет 0!</b></p>';

					}
				}
				//var_dump($values);
				$full_arr = $values;
				//array_splice($values, $topCount);
				foreach($values as $key => $value){
					if($value == 0 || !is_float($value)){
						unset($values[$key]);
					}else{
						//$values[$key] = round(castingWithMedian($full_arr, $chairsCounter, $value, $item['index_code_ru']),4);
						$values[$key] = round(actuation($full_arr, $value),4);
					}
				}
				$chair_arr[$item['index_code_ru']] = $values;
				unset($values,$full_arr);
			}

		}
	}
}
//echo '<pre>';
//var_dump($chair_arr);
//die();
# НУЖНО КОРОЧЕ ПОЛУЧИТЬ $chair_arr

# на входе массив $chair_arr с приведенными к 100 показателями

//var_dump(count($chair_arr));
# определяем массивы $chairlist $subratelist $ratelist
$rated_chairs = $db->colDocs->find($what);
foreach($rated_chairs as $chair){
	foreach($params['items'] as $item){
		if(isset($item['pdf']) && $item['pdf']){
			if(isset($item['weight'])){
				$chairlist[$item['index_code_ru']][$chair['title_ru']] = 0;
			//	var_dump($item['type']);
				if($item['type']=='subsection'){
					$subratelist[$item['index_code_ru']][$chair['title_ru']]=0;
				}
				if($item['type']=='section'){
					$ratelist[$item['index_code_ru']][$chair['title_ru']]=0;
					if(!isset($finish[$chair['title_ru']])){
						$finish[$chair['title_ru']] = 0;
					}
				}
			}
		}
	}
}

//var_dump($rated_chairs);
//$chairlist = array_reverse($chairlist);

# заполняем массивы $chairlist и $subratedlist
foreach($chairlist as $code => $chairs){
	if($weightlist[$code]['type'] == 'subsection'){
		$lastsubcode = $code;
	}
	foreach($chairs as $chair => $value){
		if(isset($chair_arr[$code][$chair]) && $weightlist[$code]['type']=='item'){
			if($lastsubcode=='ОД.2.'){
				# Отдельная хрень для расчета ДПО
				if(isset($chair_arr['ОД.2.1.'][$chair]) && isset($chair_arr['ОД.2.2.'][$chair]) && $chair_arr['ОД.2.2.'][$chair] != 0){
					$od1 = 0.1 * $chair_arr['ОД.2.1.'][$chair]/$chair_arr['ОД.2.2.'][$chair];
				}else{
					$od1 = 0;
				}
				if(isset($chair_arr['ОД.2.3.'][$chair]) && isset($chair_arr['ОД.2.4.'][$chair]) && $chair_arr['ОД.2.4.'][$chair] != 0){
					$od2 = 0.3 * $chair_arr['ОД.2.3.'][$chair]/$chair_arr['ОД.2.4.'][$chair];
				}else{
					$od2 = 0;
				}
				$subratelist[$lastsubcode][$chair] = $od1 + $od2;
				unset($od1);
				unset($od2);
			}else{
				# Стандартный расчет
				$chairlist[$code][$chair] = $chair_arr[$code][$chair]*$weightlist[$code]['weight'];
				$subratelist[$lastsubcode][$chair] += $chairlist[$code][$chair];
			}
		}
	}
}
//var_dump($subratelist);

# приводим к 100 $subratelist и домножаем на вес подраздела
foreach($subratelist as $code => $chairs){
	$chairsCounter = count($chairs);
	foreach($chairs as $chair => $value){
		//$subrate_0_100[$code][$chair] = round(castingWithMedian($chairs, $chairsCounter, $value),2)*$weightlist[$code]['weight'];
		$subrate_0_100[$code][$chair] = round(actuation($chairs, $value),2)*$weightlist[$code]['weight'];
	}
}
//var_dump($subrate_0_100);

#подсчитаем $ratelist
foreach($chairlist as $code => $chairs){
	if($weightlist[$code]['type'] == 'section'){
		$lastcode = $code;
	}
	if($weightlist[$code]['type'] == 'subsection'){
		foreach($subrate_0_100[$code] as $chair => $value){
				$ratelist[$lastcode][$chair] += $value;
		}
	}
}

//var_dump($ratelist);
# приводим к 100 $ratelist и домножаем на вес раздела
foreach($ratelist as $code => $chairs){
	//var_dump($chairs);
	$chairsCounter = count($chairs);
	foreach($chairs as $chair => $value){
		//$rate_0_100[$code][$chair] = round(castingWithMedian($chairs, $chairsCounter, $value),5);
		$rate_0_100[$code][$chair] = round(actuation($chairs, $value),2);
	}
}
//echo "<pre>";
//var_dump($weightlist);
foreach($rate_0_100 as $code => $chairs){
	foreach($chairs as $chair => $value){
		$finish[$chair] += $value*$weightlist[$code]['weight'];
	}
}
foreach($finish as $chair => $value){
	$finish_1000[$chair] = 10 * round(actuation($finish, $value),2);
}
arsort($finish_1000);
//var_dump($chairs);
$i = 0;
foreach($finish_1000 as $chairname => $value){
	if ($_GET['chairtype']!=''){
		if($_GET['chairtype'] == $chairtypes[$chairname]){
			$i++;
			$arr[$i.'. '.$chairname] = $value;
		}
	}else{
		if(!isset($_POST['faculty'])){
		$i++;
		$arr[$i.'. '.$chairname] = $value;
		}else{
			if(isset($flist[$chairname]) && $flist[$chairname]){
				$i++;
				$arr[$i.'. '.$chairname] = $value;
			}
		}
	}
}
$plotheight = 200 + 60*$i.'px';
//$finish_1000 = $arr;

$title = "Общий рейтинг";
$now = actualDate();
unset($chairs);
foreach($arr as $k => $v){
	$chairs[$k] = 10*round(actuation($arr, $v),2);
}
$plot =  $chatrs->getBar($chairs, $title, 'данные актуальны на '.$now.' г.', 'container', $plotcolor,$plotheight,'1000');
$out['head'] .= $plot['head'];
$out['body'] .= $plot['body'];
//var_dump($item);
foreach($rate_0_100 as $code => $chairs){
	$title = $itemtitles[$code];
	arsort($chairs);
	unset($arr);
	$i = 0;
	foreach($chairs as $chairname => $value){
		if ($_GET['chairtype']!=''){
			if($_GET['chairtype'] == $chairtypes[$chairname] && !isset($flist)){
				$i++;
				$arr[$i.'. '.$chairname] = $value;
			}
		}else{
			if(!isset($_POST['faculty'])){
			$i++;
			$arr[$i.'. '.$chairname] = $value;
			}else{
				if(isset($flist[$chairname]) && $flist[$chairname]){
					$i++;
					$arr[$i.'. '.$chairname] = $value;
				}
			}
		}
	}
	unset($chairs);
	if(isset($arr) && count($arr)>0){
		foreach($arr as $k => $v){
			$chairs[$k] = round(actuation($arr, $v),2);
		}
		$plot =  $chatrs->getBar($chairs, $title, 'данные актуальны на '.$now.' г.', md5($title), $plotcolor, $plotheight, '100');
		$out['head'] .= $plot['head'];
		$out['body'] .= $plot['body'];
	}
}

?><!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Рейтинг кафедр</title>
<link rel="stylesheet" href="/css/jquery-ui.css" />

<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>
<script src="/js/bootstrap.min.js"></script>
<script src="/js/highcharts/highcharts.js"></script>
<script src="/js/highcharts/highcharts-more.js"></script>
<script src="/js/highcharts/modules/exporting.js"></script>
<script src="/js/bootstrap.min.js"></script>

<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />

<link rel="stylesheet" href="/css/colors.css">
<link rel="stylesheet" href="/css/buttons.css">
<link rel="stylesheet" href="/css/positions.css">

  <script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";

  </script>
  <?php
  echo $out['head'];
  ?>
</head>

<body data-spy="scroll" data-target="#chapters">
<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Комплексный мониторинг кафедр
    </h1>
    <h2 class="header__headings__subheading">
      <small class="header__headings__subheading__subsubheading">
        Рейтинг.
      </small>
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div>
	<?php
echo $role->userMenu($user->uuid);
	?>
</div>
<!-- CURRENT PAGE -->
<div class="all">
	<div class="center">
		<div class="navbar">
			<a href="/rating.php" class="bt blue">Кафедры университета</button></a>
			<a href="/rating.php?chairtype=E" class="bt green">Естественнонаучный профиль</a>
			<a href="/rating.php?chairtype=G" class="bt red">Гуманитарный профиль</a>
			<a href="/rating.php?chairtype=T" class="bt brown">Творческий профиль</a>
			<a href="/rating.php?chairtype=P" class="bt violet">Педагогический профиль</a>
		</div>
		<?=$faculties_menu?>
		<h2 style="margin-top: 50px;"><?=$heading?></h2>
	</div>

<?php
	echo $out['body'];
?>

</div>
</body>
</html>

